/*
* generated by Xtext
*/
package es.uca.webservices.testgen.parsers.spec.xtext.ui.labeling;


import org.eclipse.emf.edit.ui.provider.AdapterFactoryLabelProvider;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.widgets.Display;
import org.eclipse.xtext.ui.label.DefaultEObjectLabelProvider;

import com.google.inject.Inject;

import es.uca.webservices.testgen.parsers.spec.xtext.testSpec.RestrictionValue;
import es.uca.webservices.testgen.parsers.spec.xtext.testSpec.Restrictions;
import es.uca.webservices.testgen.parsers.spec.xtext.testSpec.Rule;
import es.uca.webservices.testgen.parsers.spec.xtext.testSpec.StrategyReference;
import es.uca.webservices.testgen.parsers.spec.xtext.testSpec.Typedef;
import es.uca.webservices.testgen.parsers.spec.xtext.testSpec.Variable;

/**
 * Provides labels for a EObjects.
 * 
 * see http://www.eclipse.org/Xtext/documentation/latest/xtext.html#labelProvider
 */
public class TestSpecLabelProvider extends DefaultEObjectLabelProvider {

	@Inject
	public TestSpecLabelProvider(AdapterFactoryLabelProvider delegate) {
		super(delegate);
	}

	String text(Restrictions restrictions) {
		return "Restrictions";
	}
	String text(RestrictionValue restriction) {
		if(!restriction.getList().isEmpty()){
			return "List values";
		}else if(!restriction.getString().equals(null))
			return restriction.getString();
		else 
			return String.valueOf(restriction.getInt());
	}
	
	String text(Rule listStrategy) {
		return "Rule";
	}

	Image image(Variable variable) {
		return new Image(Display.getDefault(), TestSpecLabelProvider.class
			    .getResourceAsStream("/icons/declaration.gif"));
	}
	Image image(Restrictions restrictions) {
		return new Image(Display.getDefault(), TestSpecLabelProvider.class
			    .getResourceAsStream("/icons/restrictions.gif"));
	}
	
	Image image(Rule rule) {
		return new Image(Display.getDefault(), TestSpecLabelProvider.class
			    .getResourceAsStream("/icons/cian.gif"));
	}
	
	Image image(StrategyReference strategyReference) {
		return new Image(Display.getDefault(), TestSpecLabelProvider.class
			    .getResourceAsStream("/icons/verde.gif"));
	}
	
	Image image(Typedef typeDef) {
		return new Image(Display.getDefault(), TestSpecLabelProvider.class
			    .getResourceAsStream("/icons/rojo.gif"));
	}
/*
	//Labels and icons can be computed like this:
	
	String text(MyModel ele) {
	  return "my "+ele.getName();
	}
	 
    String image(MyModel ele) {
      return "MyModel.gif";
    }
*/
}
